_msgs.filter =
  [
    /* 0  */ "ERROR: Failed to get the filter statistics.",
    /* 1  */ "ERROR: Invalid IP Address.",
    /* 2  */ "ERROR: Invalid Network Mask.",
    /* 3  */ "ERROR: The address is already in the IP Address Filter Table.",
    /* 4  */ "ERROR: The IP Address Filter Table is full.",
    /* 5  */ "ERROR: Failed to add the address to the IP Address Filter Table.",
    /* 6  */ "ERROR: Must enter both an IP Address and Network Mask.",
    /* 7  */ "ERROR: IP Address not specified.",
    /* 8  */ "ERROR: Network Mask not specified.",
    /* 9  */ "ERROR: IP Address not in table.",
    /* 10 */ "ERROR: Failed to remove the IP Address.",
    /* 11 */ "The IP Address has been removed.",
    /* 12 */ "{} has been added to the IP Address Filter Table.",
  ];

function IpFilterRender(xml)
{
    var d = document.getElementById('filterdata');
    d.innerHTML = '';

    var r = '';
    var numIps = 0;

    r += GetXmlData(xml, "si") + " incoming and " + GetXmlData(xml, "so") + " outgoing packets have been filtered since the last reboot.";
    r += "<table class=\"basicTable ipFilterTable\">";
    r += "<thead><tr><th>IP Address</th><th>Network Mask</th></tr></thead><tbody>";

    for (var i = 0; xml && i < xml.childNodes.length; i++)
    {
        var node = xml.childNodes[i];

        if (node.nodeName.toLowerCase() == "f")
        {
            numIps++;

            var ip = GetXmlData(node, "i");
            var iplink = GetXmlData(node, "il");
            var mask = GetXmlData(node, "n");
            var masklink = GetXmlData(node, "nl");

            r += "<tr><td>" + ip + " [<a href=\"javascript:void(0)\" onclick=\"if (confirm('Are you SURE you want to remove this address?')) ajax_IpFilterClean([true, 'ip=" + iplink + "&amp;mask=" + masklink + "']); return false;\">Remove</a>]</td><td>" + mask + "</td></tr>";
        }
    }

    r += "</tbody></table>";

    if (!numIps)
    {
        d.innerHTML = "The IP Filter Table is empty so ALL addresses are allowed.<br/>";
    }
    else
    {
        d.innerHTML = r;
    }
}
