_msgs.net =
  [
    /* 0  */ "ERROR: Failed to enable the BOOTP Client.",
    /* 1  */ "BOOTP Client already turned on.",
    /* 2  */ "ERROR: Failed to enable the BOOTP Client.",
    /* 3  */ "BOOTP Client turned on (requires reboot).",
    /* 4  */ "ERROR: Failed to disable the BOOTP Client.",
    /* 5  */ "BOOTP Client already turned off.",
    /* 6  */ "ERROR: Failed to disable the BOOTP Client.",
    /* 7  */ "BOOTP Client turned off (requires reboot).",
    /* 8  */ "ERROR: Failed to enable the DHCP Client.",
    /* 9  */ "DHCP Client already turned on.",
    /* 10 */ "ERROR: Failed to enable the DHCP Client.",
    /* 11 */ "DHCP Client turned on (requires reboot).",
    /* 12 */ "ERROR: Failed to disable the DHCP Client.",
    /* 13 */ "DHCP Client already turned off.",
    /* 14 */ "ERROR: Failed to disable the DHCP Client.",
    /* 15 */ "DHCP Client turned off (requires reboot).",
    /* 16 */ "ERROR: Invalid IP Address",
    /* 17 */ "ERROR: Failed to commit the IP Address.",
    /* 18 */ "The IP Address has been changed (requires reboot).",
    /* 19 */ "ERROR: Invalid Network Mask.",
    /* 20 */ "ERROR: Failed to commit the Network Mask.",
    /* 21 */ "The Network Mask has been changed (requires reboot).",
    /* 22 */ "ERROR: Invalid Gateway Address.",
    /* 23 */ "ERROR: Failed to commit the Gateway.",
    /* 24 */ "The Gateway has been changed.",
    /* 25 */ "ERROR: Invalid MAC Address.",
    /* 26 */ "ERROR: Failed to commit the MAC Address.",
    /* 27 */ "The MAC Address has been changed (requires reboot).",
    /* 28 */ "ERROR: Failed to commit the Hostname.",
    /* 29 */ "The Hostname has been changed.",
    /* 30 */ "ERROR: Failed to commit the Domain.",
    /* 31 */ "The Domain has been changed.",
    /* 32 */ "ERROR: Failed to commit the DHCP Client ID.",
    /* 33 */ "The DHCP Client ID has been changed (requires reboot).",
    /* 34 */ "ERROR: Invalid Ethernet Speed setting.",
    /* 35 */ "ERROR: Failed to commit the Ethernet Speed setting.",
    /* 36 */ "The Ethernet Speed setting has been changed.",
    /* 37 */ "ERROR: Failed to renew the DHCP lease.",
    /* 38 */ "The DHCP lease has been renewed.",
    /* 39 */ "ERROR: Failed to delete the IP Address.",
    /* 40 */ "The IP Address has been deleted.",
    /* 41 */ "ERROR: Failed to delete the Network Mask.",
    /* 42 */ "The Network Mask has been deleted.",
    /* 43 */ "ERROR: Failed to delete the Gateway.",
    /* 44 */ "The Gateway has been deleted.",
    /* 45 */ "ERROR: Failed to delete the Hostname.",
    /* 46 */ "The Hostname has been deleted.",
    /* 47 */ "ERROR: Failed to delete the Domain.",
    /* 48 */ "The Domain has been deleted.",
    /* 49 */ "ERROR: Failed to delete the DHCP Client ID.",
    /* 50 */ "The DHCP Client ID has been deleted.",
    /* 51 */ "ERROR: Invalid character in the hostname.",
    /* 52 */ "ERROR: Invalid character in the domain name.",
    /* 53 */ "ERROR: Invalid Ethernet Duplex setting.",
    /* 54 */ "ERROR: Failed to commit the Ethernet Duplex setting.",
    /* 55 */ "The Ethernet Duplex setting has been changed.",
  ];

function SetNetworkLinks()
{
    var d;

    document.getElementById('netdhcpD').style.display =
        (document.getElementById('netdhcp').innerHTML == 'Off') ? 'none' : 'inline';

    d = document.getElementById('netgateway').innerHTML;
    var displayNetGateway = (
        ! (
            d == '&lt;None&gt;' ||
            d.match(/DHCP/) ||
            d.match(/BOOTP/)
        )
    );
    document.getElementById('netgatewayD').style.display =
        displayNetGateway ? 'inline' : 'none';

    d = document.getElementById('nethostname').innerHTML;
    var displayNetHostName = ( d != '&lt;None&gt;' );
    document.getElementById('nethostnameD').style.display =
        displayNetHostName ? 'inline' : 'none';

    d = document.getElementById('netdomain').innerHTML;
    document.getElementById('netdomainD').style.display =
        (d == '&lt;None&gt;') ? 'none' : 'inline';

    /* Reboot Links */

    d = document.getElementById('netrip').innerHTML;
    document.getElementById('netripD').style.display =
        (d.match(/DHCP/) || d.match(/BOOTP/) || d.match(/AutoIP/)) ? 'none' : 'inline';

    d = document.getElementById('netrmask').innerHTML;
    document.getElementById('netrmaskD').style.display =
        (d.match(/DHCP/) || d.match(/BOOTP/) || d.match(/AutoIP/)) ? 'none' : 'inline';

    d = document.getElementById('netrgateway').innerHTML;
    document.getElementById('netrgatewayD').style.display = (
        (
            displayNetGateway ||
            d == '&lt;None&gt;' ||
            d.match(/DHCP/) ||
            d.match(/BOOTP/)
        ) ? 'none' : 'inline'
    );

    d = document.getElementById('netrhostname').innerHTML;
    document.getElementById('netrhostnameD').style.display = (
        (
            displayNetHostName ||
            d == '&lt;None&gt;' ||
            d.match(/DHCP/) ||
            d.match(/BOOTP/)
        ) ? 'none' : 'inline'
    );

    d = document.getElementById('netrdci').innerHTML;
    document.getElementById('netrdciD').style.display =
        (d == '&lt;None&gt;') ? 'none' : 'inline';
}
