_msgs.stack =
  [
    /* 0  */ "TCP RSTs have been turned On.",
    /* 1  */ "TCP RSTs have been turned Off.",
    /* 2  */ "ICMP has been Enabled.",
    /* 3  */ "ICMP has been Disabled.",
    /* 4  */ "ERROR: ARP Timeout must be from 10 to 3600 seconds.",
    /* 5  */ "ERROR: Failed to commit the ARP Timeout.",
    /* 6  */ "The ARP Timeout has been changed.",
    /* 7  */ "ERROR: Invalid IP Address.",
    /* 8  */ "ERROR: Invalid MAC Address.",
    /* 9  */ "ERROR: Must enter both an IP and MAC Address.",
    /* 10 */ "The ARP Cache has been cleared.",
    /* 11 */ "ERROR: IP Address not specified.",
    /* 12 */ "ERROR: Failed to add {} to the ARP Table.",
    /* 13 */ "{} has been added to the ARP Table.",
    /* 14 */ "{} has been removed from the ARP Cache.",
  ];

function PrintTcpPostResults(xml) { PrintMsg(xml, 'tcpresults'); }
function PrintIcmpPostResults(xml) { PrintMsg(xml, 'icmpresults'); }
function PrintArpPostResults(xml) { PrintMsg(xml, 'arpresults'); }
function PrintArpCachePostResults(xml) { PrintMsg(xml, 'arpcacheresults'); }

function ArpCacheRender(xml)
{
    var d = document.getElementById('arpcachedata');
    d.innerHTML = '';

    var r = '';
    var numIps = 0;

    r += "<table class=\"basicTable protoStackArpTable\">";
    r += "<thead><tr><th>Address</th><th>Age</th><th>MAC Address</th><th>Type</th><th>Interface</th></tr></thead><tbody>";

    for (var i = 0; xml && i < xml.childNodes.length; i++)
    {
        var node = xml.childNodes[i];

        if (node.nodeName.toLowerCase() == "a")
        {
            numIps++;

            var ip = GetXmlData(node, "i");
            var iplink = GetXmlData(node, "il");
            var age = GetXmlData(node, "g");
            var mac = GetXmlData(node, "m");
            var dyn = GetXmlData(node, "d");

            r += "<tr><td>" + ip + " [<a href=\"javascript:void(0)\" onclick=\"if (confirm('Are you SURE you want to remove this address?')) ajax_ArpCacheClean([true, 'action=delete&amp;ip=" + iplink + "']); return false;\">Remove</a>]</td><td>" + age + "</td><td>" + mac + "</td><td>" + dyn + "</td><td>1</td></tr>";
        }
    }

    r += "</tbody></table>";

    if (!numIps)
    {
        d.innerHTML = "There are no entries in the ARP Cache.<br/>";
    }
    else
    {
        d.innerHTML = r;
    }
}
