_msgs.xml =
  [
    /* 0  */ "ERROR: Failed to get the list of XCR Groups.",
    /* 1  */ "ERROR: Failed to get the list of Exportable XCR Groups.",
    /* 2  */ "ERROR: Failed to get the list of Importable XCR Groups.",
    /* 3  */ "ERROR: Must specify the filename when exporting to a file.",
    /* 4  */ "ERROR: Failed to export XML configuration records.",
    /* 5  */ "ERROR: Failed to initialize export.",
    /* 6  */ "ERROR: Must specify the filename when importing from a file.",
    /* 7  */ "ERROR: Failed to import XML configuration records.",
    /* 8  */ "XML configuration records have been exported to the file {}.",
    /* 9  */ "XML configuration records have been imported from the file {}.",
    /* 10 */ "ERROR: No Content-Type Header.",
    /* 11 */ "ERROR: No Multipart Boundary.",
    /* 12 */ "ERROR: Request Timeout.",
    /* 13 */ "ERROR: Initial Multipart Boundary Error.",
    /* 14 */ "ERROR: Multipart Format Error.",
    /* 15 */ "ERROR: No Content-Disposition Header.",
    /* 16 */ "ERROR: Invalid Multipart Variable.",
    /* 17 */ "ERROR: Failed to open file.",
    /* 18 */ "ERROR: Failed to process data.",
    /* 19 */ "ERROR: Request Timeout.",
    /* 20 */ "ERROR: Multipart Boundary Error.",
    /* 21 */ "ERROR: Failed to import the XML configuration records.",
    /* 22 */ "All XML configuration records have been imported.",
    /* 23 */ "XML status records have been exported to the file {}.",
    /* 24 */ "ERROR: No groups selected for exporting.",
    /* 25 */ "ERROR: No groups selected for importing."
  ];

function PrintXmlUploadResults(xml) { PrintMsg(xml, 'xmlupload'); }

function XmlGroupsRender(xml)
{
    var d = document.getElementById('xmlgroups');
    d.innerHTML = '';

    var r = '';

    if (!xml || !xml.hasChildNodes())
    {
        r += "No XML Groups are available.";
    }
    else
    {
        r += "<table class=\"xmlFormGroupTable\">";

        var i;
        var isExportXMLConfig = false;

        for (i = 0; xml && i < xml.childNodes.length; i++)
        {
            var node = xml.childNodes[i];
            var groupId = node.nodeName.toLowerCase();
            var group = node.firstChild.nodeValue;
            var isConfigNetwork = (
                group == "ethernet" ||
                group == "interface" ||
                group == "ethernet:eth0" ||
                ( isExportXMLConfig && group.substring(0,9) == "interface" )
            );
            if ( group == "ethernet:eth0" )
            {
                isExportXMLConfig = true;
            }

            r += ((i == 0) || ((i % 2) == 0)) ? "<tr>" : "";
            r += "<td>";
            r += "<input ";
            r += "name=\"" + groupId + "\" ";
            r += "type=\"checkbox\" ";
            r += "value=\"" + encodeURIComponent(group) + "\" ";
            r += isConfigNetwork ? "unchecked " : "checked ";
            r += "/> " + group;
            r += "</td>";
            r += ((i > 0) && ((i % 2) != 0)) ? "</tr>" : "";
        }

        r += ((i > 0) && ((i % 2) != 0)) ? "<td></td></tr>" : "";
        r += "</table>";
    }

    d.innerHTML = r;
}

function SetXmlNav(xml)
{
    SetNav(xml, false, true);
}
